Draft Dimension

From FreeCAD Documentation
Jump to: navigation, search
This page contains changes which are not marked for translation.

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎русский • ‎svenska • ‎Türkçe

Draft Dimension.svg Draft Dimension

Menu location
Draft → Dimension
Workbenches
Draft, Arch
Default shortcut
D I
Introduced in version
0.8
See also
FlipDimension, TechDraw Workbench


Description

The Dimension tool creates an object that measures and displays the distance between two points; a third point specifies the position of the dimension line.

The tool can measure edges or lines directly attached to solid bodies; if the body changes, the dimension updates itself. The tool can also measure a diameter or radius of curvature such as those produced by a Draft Arc, or by the Part Fillet, Sketcher CreateFillet, and PartDesign Fillet operations.

The resulting dimension is placed in the 3D view, and is considered a Draft object. This object can be displayed on a TechDraw Workbench Page, using the TechDraw NewDraft or TechDraw NewArch tools. Alternatively, TechDraw has its own tools to display dimensions, such as TechDraw Dimension Length and TechDraw Dimension Radius; however, these tools are meant for preparing technical drawings, so they create the dimensions only in the drawing page, and not in the 3D view.

Screenshot Draft Dimension.jpg

Dimension defined by three points


How to use

  1. Press the Draft Dimension.png Draft Dimension button, or press D then I keys.
  2. Click a point on the 3D view, or type a coordinate and press the Draft AddPoint.svg add point button.
  3. Click a second point on the 3D view, or type a coordinate and press the Draft AddPoint.svg add point button. The first two points define the measured distance.
  4. Click a third on the 3D view, or type a coordinate and press the Draft AddPoint.svg add point button. The final point defines the position of the measurement line.

The dimension can be edited by double clicking on the element in the tree view, or by pressing the Draft Edit.svg Draft Edit button. Then you can move the points to a new position.

The measuring points can be changed after creation by changing the start and end properties.

The position of the measurement line can also be changed after creation by changing its direction property.

Available dimension types

Release the modifier (Alt or Shift) after picking a point or an edge.

  • Linear dimensions: hold the Alt key, or click on the View-select.svg select edge button, and pick a straight edge, then pick a second point to draw the dimension line parallel to that edge.
Note: you can also pre-select the edge before calling the tool.
  • Horizontal and vertical dimensions: pick one point, then pick a second point, then hold the Shift key and move the pointer horizontally or vertically, then pick a third point to draw the dimension line parallel to either the X axis or the Y axis.
Note 1: click and hold Shift and move the pointer in different directions many times until the dimension line aligns to the desired axis. Clicking Shift while the pointer is far from the first point will usually align the dimension to the X axis; if the pointer is close to the first point it will usually align the dimension to the Y axis.
Note 2: instead of picking two points, pick an edge while holding Alt.
  • Diameter dimensions: hold the Alt key and pick a curved edge, then pick a second point to draw the dimension line.
    • Radius dimensions: hold the Alt key and pick a curved edge, then hold the Shift key and pick a second point to draw the dimension line.
  • Angular dimensions: hold the Alt key and then pick two straight edges, then pick a point between the two edges to show the acute or obtuse angle, or elsewhere to show a supplementary or explementary angle.
Note: the displayed angle largely depends on the original position of the selected edges. If you would like to display a particular angle, you may have to add auxiliary Draft Lines that extend from the original edges, and measure these extensions.

Note: by pre-selecting an edge, or by picking it with Alt or View-select.svg select edge, the dimension will become parametric, that is, it will remember which edge it is bound to. If the endpoints of that edge move later on, the dimension will follow them, and adjust the displayed measurement.

Options

  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component. You can press the Draft AddPoint.svg add point button when you have the desired values to insert the point.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the previous one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the Dimension tool will restart after you give the final point, allowing you to draw another dimension without pressing the tool button again; the following dimensions will start from the final point of the previous dimension, and will share the same baseline.
  • Hold Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift while drawing to constrain your next point horizontally or vertically in relation to the previous one, and to switch between diameter and radius modes.
  • Press Esc or the Close button to abort the current command, and finish continued dimensions; dimensions already placed will remain.

Properties

Data

  • DATAStart: specifies the start point of the distance to measure.
  • DATAEnd: specified the end point of the distance to measure.
  • DATADimline: specifies a point through which the dimension line must pass.
  • DATADistance: (read-only) indicates the measured length.
  • DATADiameter: if it is True it displays a diameter dimension; otherwise it displays a radius dimension; this property only works if the dimension is attached to a circular arc.

View

  • VIEWExt Lines: specifies the maximum length of the extension lines that go from the measurement points to the dimension line.
  • VIEWExt Overshoot: specifies the additional length of the extension lines beyond the dimension line.
  • VIEWDim Overshoot: specifies the additional length added to the dimension line.
  • VIEWArrow Size: specifies the size of the symbol displayed at the ends of the dimension line.
  • VIEWArrow Type: specifies the type of symbol displayed at the ends of the dimension line, which can be "Dot", "Circle", "Arrow", or "Tick".
  • VIEWFlip Arrows: specifies whether to flip the orientation of the symbols at the ends of the dimension line; it only works if these symbols are arrows.
  • VIEWFont Name: specifies the font to use to draw the text. It can be a font name, such as "Arial", a default style such as "sans", "serif" or "mono", a family such as "Arial,Helvetica,sans" or a name with a style such as "Arial:Bold". If the given font is not found on the system, a generic one is used instead.
  • VIEWFont Size: specifies the size of the letters. If the dimension object is created in the tree view but no text is visible, increase the size of the text until it is visible.
  • VIEWFlip Text: specifies whether to flip the orientation of the text indicating the measurement.
  • VIEWText Position: specifies the position of the text in absolute coordinates, referred to the origin (0,0,0); leave this property at its default value (0,0,0) to display the text next to the dimension line.
  • VIEWText Spacing: specifies the space between the text and the dimension line.
  • VIEWOverride: specifies a custom text to display instead of the actual measurement. Use the string $dim inside the text to display the measurement value.
  • VIEWDecimals: specifies the number of decimal places to display on the measurement.
  • VIEWShow Unit: if it is True the unit is displayed next to numerical value of the measurement.
  • VIEWUnit Override: specifies a unit in which to express the measurement, for example, "km", "m", "cm", "mm", "mi", "ft", "in"; leave this property blank to use the default units. available in version 0.17

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The Dimension tool can be used in macros and from the Python console by using the following function:

Dimension = makeDimension(p1, p2, p3=None, p4=None)

There are various ways to invoke this function, depending on the arguments passed to it:

Dimension = makeDimension(p1, p2, p3=None)
Dimension = makeDimension(object, i1, i2, p4=None)
Dimension = makeDimension(object, i1, mode, p4=None)
  • Creates a linear Dimension by measuring the distance between points p1 and p2.
  • Creates a linear Dimension linked to object, measuring the distance between its vertices indexed i1 and i2.
  • Creates a circular Dimension linked to object, with i1 being the index of the curved edge to measure, and mode being either "radius" or "diameter" to specify the type of dimension.
    • p3 in the first call, and p4 in the other two, specify an optional point through which the dimension line should go.
    • All points are defined by their FreeCAD.Vector.

To create an angular dimension use the following function:

Dimension = makeAngularDimension(center, angles, p3, normal=None)
Dimension = makeAngularDimension(center, [angle1, angle2], p3, normal=None)
  • Creates an angular Dimension from the given center point, the angles list with two elements, and the point p3 through which the arc should go.
    • If angle1 > angle2, the displayed angle is the difference angle1 - angle2; otherwise, the explementary angle is displayed, 360 - (angle2 - angle1).
    • The angles should be given in radians; the math.radians() function can be used to convert angles given in degrees.

The view properties of Dimension can be changed by overwriting its attributes; for example, overwrite ViewObject.FontSize with the new size in millimeters.

Example:

import math, FreeCAD, Draft

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1000, 1000, 0)
p3 = FreeCAD.Vector(-2500, 0, 0)
Dimension1 = Draft.makeDimension(p1, p2, p3)
Dimension1.ViewObject.FontSize = 200

Polygon = Draft.makePolygon(3, radius=1000)
p4 = FreeCAD.Vector(-2000, 1500, 0)
Dimension2 = Draft.makeDimension(Polygon, 1, 2, p4)
Dimension2.ViewObject.FontSize = 200

center = FreeCAD.Vector(2000, 0, 0)
p5 = FreeCAD.Vector(3000, 1000, 0)
angle1 = math.radians(45)
angle2 = math.radians(10)
Dimension3 = Draft.makeAngularDimension(center, [angle1, angle2], p5)
Dimension3.ViewObject.FontSize = 200

Dimension4 = Draft.makeAngularDimension(center, [angle2, angle1], p5*1.2)
Dimension4.ViewObject.FontSize = 200

Links